package com.jkcredit.illegal.info.util;

import org.apache.tomcat.util.codec.binary.Base64;

import javax.crypto.BadPaddingException;
import javax.crypto.Cipher;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.spec.SecretKeySpec;
import java.io.IOException;
import java.nio.charset.Charset;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;

/**
 * @author xusonglin
 * @version V1.0
 **/
public class AesUtil {
    public static String encryAES(String content, String passWord) throws Exception {
        //原始字节数组
        byte[] passwordBytes = passWord.getBytes(Charset.forName("utf-8"));
        SecretKeySpec key = new SecretKeySpec(passwordBytes,"AES");
        //6.根据指定算法AES自成密码器
        Cipher cipher= Cipher.getInstance("AES");
        //7.初始化密码器，第一个参数为加密(Encrypt_mode)或者解密解密(Decrypt_mode)操作，第二个参数为使用的KEY
        cipher.init(Cipher.ENCRYPT_MODE, key);
        //8.获取加密内容的字节数组(这里要设置为utf-8)不然内容中如果有中文和英文混合中文就会解密为乱码
        byte [] byte_encode=content.getBytes("utf-8");
        //9.根据密码器的初始化方式--加密：将数据加密
        byte [] byte_AES=cipher.doFinal(byte_encode);
        //10.将加密后的数据转换为字符串
        //这里用Base64Encoder中会找不到包
        //解决办法：
        //在项目的Build path中先移除JRE System Library，再添加库JRE System Library，重新编译后就一切正常了。
        String AES_encode =  Base64.encodeBase64String(byte_AES);
        //11.将字符串返回
        return AES_encode;
    }

    public static String decryAES(String passWord, String content) throws IOException, NoSuchPaddingException, NoSuchAlgorithmException, InvalidKeyException, BadPaddingException, IllegalBlockSizeException {
        //5.根据字节数组生成AES密钥
        byte[] passwordBytes = passWord.getBytes(Charset.forName("utf-8"));

        SecretKeySpec key = new SecretKeySpec(passwordBytes,"AES");
        //6.根据指定算法AES自成密码器
        Cipher cipher= Cipher.getInstance("AES");
        //7.初始化密码器，第一个参数为加密(Encrypt_mode)或者解密(Decrypt_mode)操作，第二个参数为使用的KEY
        cipher.init(Cipher.DECRYPT_MODE, key);
        //8.将加密并编码后的内容解码成字节数组
        byte [] byte_content = Base64.decodeBase64(content.getBytes("utf-8"));
        /*
         * 解密
         */
        byte [] byte_decode=cipher.doFinal(byte_content);
        String AES_decode=new String(byte_decode,"utf-8");
        return AES_decode;
    }

    public static void main(String[] args) {
        String password = "374c72b109292ad4";
        String body = "{\"name\":\"丰城市景丰物流有限公司\",\"idCode\":\"\",\"traceId\":\"test-10000002\",\"plateNumber\":\"赣C3J448\",\"plateColor\":\"01\"}";
        Long startTime = System.currentTimeMillis();
        try {
            String encryptString = encryAES(body, password);
            System.out.println("加密耗时：" + (System.currentTimeMillis()-startTime));
            System.out.println("加密：" + encryptString);

            startTime = System.currentTimeMillis();
            String decryptString = decryAES(password, encryptString);
            System.out.println("解密耗时：" + (System.currentTimeMillis()-startTime));
            System.out.println("解密：" + decryptString);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
